;; 
LineCounter     DB      1
DebugFlag       DB      1
InKeyFlag       DB      1
;; 
HalfByteToHex   Proc    Near
                Cmp     AL,9
                JBE     @@1
                Add     AL,'A'-10-'0'
@@1:
                Add     AL,'0'
                Ret
                EndP
;; 
ByteToHex       Proc    Near
                Mov     BL,AH
                Mov     AH,AL
                And     AL,0Fh
                Shr     AH,4
                Call    HalfByteToHex
                Xchg    AL,AH
                Call    HalfByteToHex
                Ret
                EndP
;; 
DisplayByte     Proc    Near  Uses AX DX
                Call    ByteToHex
                Mov     DX,AX
                Mov     AH,2
                Int     021h
                Mov     DL,DH
                Int     021h
                Ret
                EndP
;; 
DisplayWord     Proc    Near  Uses AX
                Xchg    AL,AH
                Call    DisplayByte
                Mov     AL,AH
                Call    DisplayByte
                Ret
                EndP
;; 
DisplayDevider  Proc    Near
                Mov     DL,''
                Mov     AH,2
                Int     021h
                Ret
                EndP
;; 
InfoLine        DB      'Mnemonic         AF  BC  DE  HL  IX  IY  SP  PC PSSS',0Dh,0Ah
                DB      78 Dup ('')
                DB      0Dh,0Ah,'$'
;; 
SaveRegs        DW      12 dup (?)

DisplayStatus   Proc    Near   Uses AX BX CX DX DI SI
                PushF
                In      AL,061h
                Xor     AL,2
;               Out     061h,AL
                Cmp     DebugFlag,1
                JNE     @@Kbd

                Dec     LineCounter
                JNZ     @@1
                Push    DS
                Mov     AX,CS
                Mov     DS,AX
                Mov     LineCounter,23
                Mov     DX,Offset InfoLine
                Mov     AH,9
                Int     021h
                Pop     DS
@@1:
                Dec     DI
                Mov     CL,CS:[DI]
                Xor     CH,CH
                JCXZ    @@Skip
                Mov     BL,16
                Sub     BL,CL
                Mov     AH,2
                Sub     DI,CX
@@2:
                Mov     DL,CS:[DI]
                Int     021h
                Inc     DI
                Loop    @@2

                Mov     CL,BL
                Mov     DL,''
                Mov     AH,2
@@5:
                Int     021h
                Loop    @@5
                Call    DisplayDevider

                mov     ax,CS:Reg_AF
                Call    DisplayWord
                Call    DisplayDevider

                mov     ax,CS:Reg_BC
                Call    DisplayWord
                Call    DisplayDevider

                mov     ax,CS:Reg_DE
                Call    DisplayWord
                Call    DisplayDevider

                mov     ax,CS:Reg_HL
                Call    DisplayWord
                Call    DisplayDevider

                Mov     ax,CS:IX
                Call    DisplayWord
                Call    DisplayDevider

                Mov     ax,CS:IY
                Call    DisplayWord
                Call    DisplayDevider

                mov     ax,CS:Reg_SP
                Call    DisplayWord
                Call    DisplayDevider

                mov     ax,CS:Reg_PC
                Call    DisplayWord
                Call    DisplayDevider

                Mov     AL,CurrentPrimarySlot
                Call    DisplayByte
                Call    DisplayDevider

                Mov     AL,CurrentSecondarySlot
                Not     AL
                Call    DisplayByte
                Call    DisplayDevider
@@Kbd:
                Mov     AH,1
                Int     016h
                JNZ     @@15
                Cmp     DebugFlag,1
                JNE     @@Skip
                Cmp     InKeyFlag,1
                JNE     @@11
@@15:
                Mov     AH,0
                Int     016h
                Cmp     AL,27
                JNE     @@3
                Xor     DebugFlag,1
                JNZ     @@Skip
@@3:
                Cmp     AL,' '
                JNE     @@10
                Xor     InKeyFlag,1
@@10:
                Cmp     AL,'q'
                JNE     @@11
                Call    ResetTimer
                Mov     AX,04C00h
                Int     021h
@@11:
                Mov     AH,2
                Mov     DL,0Dh
                Int     021h
                Mov     DL,0Ah
                Int     021h
                Mov     IntREQ,0
@@Skip:
                PopF
                Ret
                EndP
